/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

function dibujar_fondo(){
	//Drawing the background according with the grid
	var i,j;
	for(i=0;i<GRID_ROWS;i++){
		for(j=0;j<GRID_COLUMNS;j++){
			if(grid.grid[i][j]==1){
				contexto.drawImage(grid.imagen, tam_image_square_x*j, tam_image_square_y*i, 
								tam_image_square_x, tam_image_square_y,
								TAM_GRID_SQUARE_X*j, TAM_GRID_SQUARE_Y*i, 
								TAM_GRID_SQUARE_X, TAM_GRID_SQUARE_Y);
			}
		}
	}
}

function dibujar_bandas(){

	if(fadein_alpha<=0){
		for(i=0;i<bandas.bandas.length;i++){
			if(bandas.bandas[i].alpha>0){
				contexto.save();
				if(bandas.bandas[i].alpha==1){
					contexto.shadowColor = "#666";
					contexto.shadowOffsetX = 3;
					contexto.shadowOffsetY = 3;
					contexto.shadowBlur = 3;
				}
				dibujar_banda(bandas.bandas[i],i);
				contexto.restore();
			}
		}
	}
}

function dibujar_banda(banda,i){
	var gradiente = contexto.createRadialGradient(banda.x, banda.y, 20, 
															banda.x, banda.y, 300);		
	if(i==bandas.banda_destacada){
		gradiente.addColorStop(0, "#F8FFAF");
		gradiente.addColorStop(1, "#6ED500");
	}else{
		gradiente.addColorStop(0, "#D6FF8E");
		gradiente.addColorStop(1, "#4CB300");
	}
	contexto.fillStyle = gradiente;
	if(contexto.globalAlpha>0)
		contexto.globalAlpha=bandas.bandas[i].alpha;
	contexto.beginPath();
	var w=200*banda.escala;
	var h=100*banda.escala;
	roundRect(banda.x+100-w/2, banda.y+50-h/2, w, h, 50*banda.escala);
	contexto.fill();
	var text=banda.name;
	var text_width = contexto.measureText(text).width;
	if(banda.show_text){
		contexto.fillStyle = "#FFFFFF"; // Color del texto
		contexto.font = "bold 20px Comic Sans"; // Tamano y estilo de la fuente
		if(banda.centrar)
			banda.name.dibujar(banda.x+30,banda.y+35);
		else
			banda.name.dibujar(0,0);			
	}
	contexto.closePath();

	if(banda.centrar){	
		//Dibujamos las opciones
		var j;
		for(j=0;j<bandas.opciones.length;j++)
			if(j==bandas.opcion_destacada)
				contexto.drawImage(bandas.opciones[j].over_image, bandas.opciones[j].x, bandas.opciones[j].y, bandas.opciones[j].w, bandas.opciones[j].h);
			else
				contexto.drawImage(bandas.opciones[j].image, bandas.opciones[j].x, bandas.opciones[j].y, bandas.opciones[j].w, bandas.opciones[j].h);

		//Dibujamos los miembros
		contexto.shadowOffsetX = 0;
		contexto.shadowOffsetY = 0;
		for(j=0;j<banda.members.length;j++){
            contexto.drawImage(banda.members[j].cara_img, banda.members[j].getXCara(),banda.members[j].getYCara(),banda.members[j].cara_w,banda.members[j].cara_h);
            contexto.drawImage(banda.members[j].cuerpo_img[0], banda.members[j].x, banda.members[j].y, banda.members[j].cuerpo_width, banda.members[j].cuerpo_height);
            if(j==bandas.bandas[bandas.banda_destacada].opcion_destacada)
				contexto.drawImage(banda.opciones[j].over_image, banda.opciones[j].x, banda.opciones[j].y, banda.opciones[j].w, banda.opciones[j].h);
			else
				contexto.drawImage(banda.opciones[j].image, banda.opciones[j].x, banda.opciones[j].y, banda.opciones[j].w, banda.opciones[j].h);
		}
	}		
}

function dibujar_depurar(){
	
	contexto.save();
	//Showing the grid
	contexto.strokeStyle = '#F0F'; // Color
	for(i=0;i<GRID_ROWS;i++){
		contexto.beginPath();
		contexto.moveTo(0,TAM_GRID_SQUARE_Y*i);
		contexto.lineTo(ANCHURA_VENTANA,TAM_GRID_SQUARE_Y*i);
		contexto.closePath();
		contexto.stroke();
	}
	
	for(i=0;i<GRID_COLUMNS;i++){
		contexto.beginPath();
		contexto.moveTo(TAM_GRID_SQUARE_X*i,0);
		contexto.lineTo(TAM_GRID_SQUARE_X*i,ALTURA_VENTANA);
		contexto.closePath();
		contexto.stroke();
	}
	contexto.restore();
}

function dibujar_menu(){
    
    if(menu.estado==DESPLEGAR_MENU || menu.estado==REPLEGAR_MENU){        
        var i;
        for(i=0;i<menu.botones.length;i++){
			if(i==menu_button_pointed)
				contexto.drawImage(menu.botones[i].over_image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
			else
				contexto.drawImage(menu.botones[i].image, menu.botones[i].x, menu.y, menu.botones[i].w, menu.botones[i].h);
        }
	}
}

function roundRect(x, y, width, height, radius) {
    contexto.beginPath();
    contexto.moveTo(x + radius, y);
    contexto.lineTo(x + width - radius, y);
    contexto.arc(x+width-radius, y+radius, radius, -Math.PI/2, Math.PI/2, false);
    contexto.lineTo(x + radius, y + height);
    contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    contexto.closePath();
    contexto.fill();
}

function progressLayerRect(x, y, width, height, radius) {
    contexto.save();
    // Define the shadows
    contexto.shadowOffsetX = 2;
    contexto.shadowOffsetY = 2;
    contexto.shadowBlur = 5;
    contexto.shadowColor = '#666';
 
     // first grey layer
    contexto.fillStyle = 'rgba(189,189,189,1)';
    roundRect(x, y, width, height, radius);
 
    // second layer with gradient
    // remove the shadow
    contexto.shadowColor = 'rgba(0,0,0,0)';
    var lingrad = contexto.createLinearGradient(0,y+height,0,0);
    lingrad.addColorStop(0, 'rgba(255,255,255, 0.1)');
    lingrad.addColorStop(0.4, 'rgba(255,255,255, 0.7)');
    lingrad.addColorStop(1, 'rgba(255,255,255,0.4)');
    contexto.fillStyle = lingrad;
    roundRect(x, y, width, height, radius);
 
    contexto.restore();
}

function progressBarRect(x, y, width, height, radius, max) {
    contexto.save();
	
	// Blue gradient for progress bar
	var progress_lingrad = contexto.createLinearGradient(0,250,0,0);
	progress_lingrad.addColorStop(0, '#4DF3A4');
	progress_lingrad.addColorStop(0.4, '#ADFFD9');
	progress_lingrad.addColorStop(1, '#9EFFD1');
	
    // deplacement for chord drawing
    var offset = 0;
    contexto.beginPath();
    if (width<radius) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius-width),2));
        // Left angle
        var left_angle = Math.acos((radius - width) / radius);
        contexto.moveTo(x + width, y+offset);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x + radius, y + radius, radius, Math.PI - left_angle, Math.PI + left_angle, false);
    }
    else if (width+radius>max) {
        offset = radius - Math.sqrt(Math.pow(radius,2)-Math.pow((radius - (max-width)),2));
        // Right angle
        var right_angle = Math.acos((radius - (max-width)) / radius);
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.arc(x+max-radius, y + radius, radius, -Math.PI/2, -right_angle, false);
        contexto.lineTo(x + width, y+height-offset);
        contexto.arc(x+max-radius, y + radius, radius, right_angle, Math.PI/2, false);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    else {
        contexto.moveTo(x + radius, y);
        contexto.lineTo(x + width, y);
        contexto.lineTo(x + width, y + height);
        contexto.lineTo(x + radius, y + height);
        contexto.arc(x+radius, y+radius, radius, Math.PI/2, 3*Math.PI/2, false);
    }
    contexto.closePath();
    contexto.fillStyle = progress_lingrad;
    contexto.fill();
	
	// texto
    var text = Math.floor(width/max*100)+"%";
    var text_width = contexto.measureText(text).width;
    var text_x = x+width-text_width-radius/2;
    if (width<=radius+text_width) {
        text_x = x+radius/2;
    }
		
    contexto.fillStyle = "#FFFFFF"; // Color del texto
    contexto.font = "bold 20px Comic Sans"; // Tamano y estilo de la fuente
    contexto.fillText(text, text_x, y+22);
	
    contexto.restore();
}

function draw_progressbar(){
	if(progreso>100) progreso=100;	
	contexto.save();
	var gradiente = contexto.createRadialGradient(ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 20, ANCHURA_VENTANA/2, ALTURA_VENTANA/2, 200);
    gradiente.addColorStop(0, "#8ED6FF");
    gradiente.addColorStop(1, "#004CB3");
    contexto.fillStyle = gradiente;
    contexto.fill();
	contexto.beginPath();
	contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
	contexto.closePath();
	contexto.fill();
	contexto.restore();
	var initial_x=(ANCHURA_VENTANA/2)-150;
	var initial_y=(ALTURA_VENTANA/2)-25;
	progressLayerRect(initial_x, initial_y, 300, 50, 25);
	progressBarRect(initial_x, initial_y, (3*progreso), 50, 25, 300);
}

function draw_fadein(){
	if(fadein_alpha>0.0){
		contexto.save();
		contexto.globalAlpha=fadein_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadein_alpha-=FADE_SPEED;
		contexto.restore();
		if(fadein_alpha<=0.0){
			//Inicializamos las bandas
			lanzar_bandas();
			desbloquear();
		}
	}
}

function draw_fadeout(){
	if(fadeout_alpha<1.0){
		contexto.save();
		contexto.globalAlpha=fadeout_alpha;
		contexto.fillStyle = "#000000";
		contexto.beginPath();
		contexto.rect(0, 0, ANCHURA_VENTANA, ALTURA_VENTANA);
		contexto.closePath();
		contexto.fill();
		fadeout_alpha+=FADE_SPEED;
		contexto.restore();
		if(fadeout_alpha>=1.0){
			contexto.globalAlpha=0.0;
			redireccionar(url_redireccionar);
		}
	}
}

function dibujar_dialogo(){
	if(dialogo.tag!=-1){
		contexto.save();
		
		//Definimos las sombras
		contexto.shadowOffsetX = 5;
		contexto.shadowOffsetY = 5;
		contexto.shadowBlur = 5;
		contexto.shadowColor = '#666';
		
		//Dibujamos el marco
		if(dialogo.alpha<1.0){
			contexto.globalAlpha=dialogo.alpha;
			dialogo.alpha+=0.1;
		}
		var gradiente = contexto.createRadialGradient(dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 20, dialogo.x+dialogo.w/2, dialogo.y+dialogo.h/2, 200);
		gradiente.addColorStop(0, "#8ED6FF");
		gradiente.addColorStop(1, "#004CB3");
		contexto.fillStyle = gradiente;
		contexto.beginPath();
		contexto.rect(dialogo.x, dialogo.y, dialogo.w, dialogo.h);
		contexto.closePath();
		contexto.fill();		
			
		//Dibujamos el mensaje de texto
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.textBaseline = "top"; // Linea base del texto
		contexto.font = "bold 18px Comic Sans"; // Tamano y estilo de la fuente
		contexto.fillText("Eliminar a este miembro de la banda?", dialogo.x+10, dialogo.y+10); // Pintamos el texto.
		
		//Dibujamos las opciones
		var i;
		for(i=0;i<dialogo.coordenadas_opciones.length;i++){
			var gradiente = contexto.createRadialGradient(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 20,
															dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], 300);		
			if(i==dialogo.opcion_apuntada){
				gradiente.addColorStop(0, "#F8FFAF");
				gradiente.addColorStop(1, "#6ED500");
			}else{
				gradiente.addColorStop(0, "#D6FF8E");
				gradiente.addColorStop(1, "#4CB300");
			}
			contexto.fillStyle = gradiente;

			contexto.beginPath();
			roundRect(dialogo.coordenadas_opciones[i][0], dialogo.coordenadas_opciones[i][1], dialogo.opcion_w, dialogo.opcion_h, 25);
			
			contexto.fill();
		}
		
		//Dibujamos el texto de las opciones
		contexto.fillStyle = "#000000"; // Color del texto
		contexto.fillText("Aceptar", dialogo.coordenadas_opciones[0][0]+15, dialogo.coordenadas_opciones[0][1]+13);
		contexto.fillText("Rechazar", dialogo.coordenadas_opciones[1][0]+15, dialogo.coordenadas_opciones[1][1]+13);

		contexto.restore();
	}
}